import 'package:barback/barback.dart';
import 'dart:async';
import 'dart:io';

class MythTransformer extends Transformer {
  final BarbackSettings _settings;
  String get allowedExtensions => ".css";
  MythTransformer.asPlugin(this._settings);
  
  Future apply(Transform transform) async {   
   String content = await transform.primaryInput.readAsString();
   String newContent;
   
   // Gather the command line args from pubspec.yaml
   List args = [];
   if (_settings.configuration['args'] != null)
     args.addAll(_settings.configuration['args']);   
   
   // Begin the myth process
   Process myth = await Process.start('myth', args)
    ..stderr.listen((output) => transform.logger.warning(new String.fromCharCodes(output)));
   
   // Setup listener for when myth outputs
    myth.stdout.listen((output) {
     newContent = new String.fromCharCodes(output);
     myth.kill();
   });
    
   // Add our source file and close
   myth.stdin.add(content.codeUnits);
   myth.stdin.close();
   
   // Wait for myth to end, then collect the spoils.
   await myth.exitCode;
   var id = transform.primaryInput.id;
   transform.addOutput(new Asset.fromString(id, newContent));
   return;
  }
}